import { Record, Union } from "../fable_modules/fable-library.3.6.2/Types.js";
import { list_type, record_type, union_type, string_type } from "../fable_modules/fable-library.3.6.2/Reflection.js";
import { empty, tryFind } from "../fable_modules/fable-library.3.6.2/List.js";
import { useReact_useEffect_3A5B6456, useFeliz_React__React_useState_Static_1505 } from "../fable_modules/Feliz.1.57.0/React.fs.js";
import { join, toConsole } from "../fable_modules/fable-library.3.6.2/String.js";
import { fetch$ } from "../fable_modules/Fable.Fetch.2.4.0/Fetch.fs.js";
import { format as format_1 } from "date-fns";
import { Auto_generateBoxedDecoder_79988AEF, fromString } from "../fable_modules/Thoth.Json.6.0.0/Decode.fs.js";
import { uncurry } from "../fable_modules/fable-library.3.6.2/Util.js";
import { CaseStrategy } from "../fable_modules/Thoth.Json.6.0.0/Types.fs.js";
import { createElement } from "react";
import { Interop_reactApi } from "../fable_modules/Feliz.1.57.0/Interop.fs.js";

export class State extends Union {
    constructor(tag, ...fields) {
        super();
        this.tag = (tag | 0);
        this.fields = fields;
    }
    cases() {
        return ["LoadingScore", "ErrorFetchingScore", "LoadedScore", "NoScore"];
    }
}

export function State$reflection() {
    return union_type("UserEntry.State", [], State, () => [[], [], [["Item", string_type]], []]);
}

export class Score extends Record {
    constructor(Name, Time) {
        super();
        this.Name = Name;
        this.Time = Time;
    }
}

export function Score$reflection() {
    return record_type("UserEntry.Score", [], Score, () => [["Name", string_type], ["Time", string_type]]);
}

export function GetUserScore(scores, username) {
    const _arg1 = tryFind((u) => (u.Name === username), scores);
    if (_arg1 == null) {
        return new State(3);
    }
    else {
        return new State(2, _arg1.Time);
    }
}

export function UserEntry(userEntryInputProps) {
    const currentDate = userEntryInputProps.currentDate;
    const username = userEntryInputProps.username;
    const patternInput = useFeliz_React__React_useState_Static_1505(new State(0));
    const setScore = patternInput[1];
    const score = patternInput[0];
    [useReact_useEffect_3A5B6456(() => {
        let pr_1, pr;
        toConsole(`Current Date == ${currentDate}`);
        (pr_1 = ((pr = fetch$(`https://acicchetti.dev/crossword/v1/${format_1(currentDate, "yyyy-MM-dd")}`, empty()), pr.then((res) => res.text()))), pr_1.then((txt) => {
            const decoded = fromString(uncurry(2, Auto_generateBoxedDecoder_79988AEF(list_type(Score$reflection()), new CaseStrategy(1), void 0)), txt);
            if (decoded.tag === 1) {
                setScore(new State(1));
            }
            else {
                const apiResponse = decoded.fields[0];
                toConsole(`got ${apiResponse}`);
                setScore(GetUserScore(apiResponse, username));
            }
        }));
    }), [currentDate]];
    return createElement("div", {
        className: join(" ", [(() => {
            throw 1;
        })()]),
        children: Interop_reactApi.Children.toArray([createElement("div", {
            children: `${username} - ${((score.tag === 1) ? "Error Fetching Score" : ((score.tag === 2) ? score.fields[0] : ((score.tag === 3) ? "No Score" : "Loading")))}`,
        })]),
    });
}

